const char	*AppTitle = "Decoder 5 Overlay";
#include <stdio.h>
#include <windows.h>

#include <math.h>
#include <limits.h>
#include <fcntl.h>
#include <io.h>
#include <sys/stat.h>
#include <time.h>
#include <ddraw.h>
#include <vfw.h>
#include <dsound.h>
#include <wingdi.h>
#include <winuser.h>

#include <stdio.h>
#include <stdlib.h>

#include "cpuid.h"
#include "btxxx.h"
#include "ccrypt.h"
#include "video.h"
#include "DukeDecode.h"

#define IDM_FILE_SUBMENU_POS		0
#define IDM_DECODER_SUBMENU_POS		1
#define IDM_OPTIONS_SUBMENU_POS		2
#define IDM_HELP_SUBMENU_POS		3

#define IDM_MANUAL_INVERT			51

#define IDM_AUTO_INVERT_NONE		60
#define IDM_AUTO_INVERT_NORMAL		61
#define IDM_AUTO_INVERT_WHITE_CROSS	62

#define IDM_DECODE_MODE				100

#define IDM_AUTO_LOCK_MODE1			150
#define IDM_AUTO_LOCK_MODE2			151
#define IDM_AUTO_LOCK_MODE3			152

#define IDM_ALWAYS_ON_TOP			500
#define IDM_ASPECT_RATIO			501
#define IDM_CLI						502
#define IDM_TOGGLE_FULLSCREEN		505
#define IDM_USE_DOUBLE_BUFFERING	507
#define IDM_FORCE_VSEARCH			510
#define IDM_KEY_HELP				511
#define IDM_SHOW_DEBUG				512

#define IDM_SVIDEO					550
#define IDM_TUNER					551
#define IDM_COMPOSITE				552

#define IDM_SNAPSHOT				600
#define IDM_SNAPSHOTS				601

#define IDM_EXIT					1000
#define IDM_ABOUT					1001
#define IDM_SYSTEM_INFO				1002

#define D_PLL_FREQ					35437000



//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#define I2CBITTIME		(0x5<<4)	/* 5 * 0.48uS */
#define I2CBITTIME_878              (1 << 7)
#define I2C_READ		0x01
#define I2C_COMMAND		(I2CBITTIME |			\
				 BT848_DATA_CTL_I2CSCL |	\
				 BT848_DATA_CTL_I2CSDA)


#define LOW_BAND 0
#define MID_BAND 1
#define HIGH_BAND 2
#define FM_RADIO_BAND 3

/* Check if these are correct for other than Philips PAL */
#define STATUSBIT_COLD   0x80
#define STATUSBIT_LOCK   0x40
#define STATUSBIT_TV     0x20
#define STATUSBIT_STEREO 0x10 /* valid if FM (aka not TV) */
#define STATUSBIT_ADC    0x07

#define AFC_DELAY               10000   /* 10 millisend delay */
#define AFC_BITS                0x07
#define AFC_FREQ_MINUS_125      0x00
#define AFC_FREQ_MINUS_62       0x01
#define AFC_FREQ_CENTERED       0x02
#define AFC_FREQ_PLUS_62        0x03
#define AFC_FREQ_PLUS_125       0x04
#define AFC_MAX_STEP            (5 * FREQFACTOR) /* no more than 5 MHz */
  
#define TTYPE_XXX               0
#define TTYPE_NTSC              1
#define TTYPE_NTSC_J            2
#define TTYPE_PAL               3
#define TTYPE_PAL_M             4
#define TTYPE_PAL_N             5
#define TTYPE_SECAM             6
  
#define TSA552x_CB_MSB          (0x80)
#define TSA552x_CB_CP           (1<<6)	/* set this for fast tuning */
#define TSA552x_CB_T2           (1<<5)	/* test mode - Normally set to 0 */
#define TSA552x_CB_T1           (1<<4)	/* test mode - Normally set to 0 */
#define TSA552x_CB_T0           (1<<3)	/* test mode - Normally set to 1 */
#define TSA552x_CB_RSA          (1<<2)	/* 0 for 31.25 khz, 1 for 62.5 kHz */
#define TSA552x_CB_RSB          (1<<1)	/* 0 for FM 50kHz steps, 1 = Use RSA*/
#define TSA552x_CB_OS           (1<<0)	/* Set to 0 for normal operation */

#define TSA552x_RADIO           (TSA552x_CB_MSB |       \
                                 TSA552x_CB_T0)

/* raise the charge pump voltage for fast tuning */
#define TSA552x_FCONTROL        (TSA552x_CB_MSB |       \
                                 TSA552x_CB_CP  |       \
                                 TSA552x_CB_T0  |       \
                                 TSA552x_CB_RSA |       \
                                 TSA552x_CB_RSB)
  
/* lower the charge pump voltage for better residual oscillator FM */
#define TSA552x_SCONTROL        (TSA552x_CB_MSB |       \
                                 TSA552x_CB_T0  |       \
                                 TSA552x_CB_RSA |       \
                                 TSA552x_CB_RSB)



//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
extern unsigned char	scanLuma[720*288];
extern unsigned char* pixels;
char info_text_buffer[1024];

extern int decWidth,quality=0;

unsigned int frame=0;
int frames_in_buffer=0,current_frame=0,frame_flip=0;
__int64 nowms,startms=0,ms1,ms2;


int fd,saving=0,playing=0,save_y;

extern unsigned char* pixels;
extern int pitch;

unsigned char *s0;

int VirtualDecoder::_cb_width = 162;
extern int craita,braita;
int frame_id,frame_id_prev,waiting;

static void setModeRGB24(void);

int maxx_cnt=0,maxx_x[16],maxx_nbr[16];


extern bool adjust_luma_level;
typedef struct CLR_CFG
{
	int brightness;
	int contrast;
	int saturation;
} CLR_CFG;

extern CLR_CFG color_cfg[2];


int joku_x,resolution=1;

bool disable_ints=1;
unsigned long *fid;
unsigned long frameaddr;
int frameadd;

int microsec_cnt=0,microsecs[16],microsec_min=1000000;

int move_y=0,move_x=0,move_cnt=0;

int	decode_mode=0;

int lock_difference,lock_x;

int border_x=0,border_y=0,start_y2=0;
extern unsigned long int stripe[280];
int x,y,z;

extern int lladjust4;

int lladjust2=-64;
int count=0,counter=1;

typedef struct
{
	int *LinAddr;
	int *PhysAddr;
	int size;
	int __reserved;
} MEMBLK;						// physical memory block structure

extern long unsigned int raidat=128;
int horiz_x=0,sec_time;


/*
 dynamically load PHYSMEM, do Ioctl call and close handle
*/
bool PhysmemIoctl( int dwIoControlCode, void *lpInBuffer, int nInBufferSize,
                   void *lpOutBuffer, int nOutBufferSize )
{
	unsigned long  nBytesReturned=0;
	bool result;

	HANDLE hVxD = CreateFile( "\\\\.\\PHYSMEM.VXD", 0,0,0,0, FILE_FLAG_DELETE_ON_CLOSE, 0 );

	if (hVxD == INVALID_HANDLE_VALUE)
	{
		FATAL( "Couldn't load PHYSMEM VxD" );
	}
	result = DeviceIoControl( hVxD, dwIoControlCode, lpInBuffer, nInBufferSize,
							  lpOutBuffer, nOutBufferSize, &nBytesReturned, FALSE );
	CloseHandle( hVxD );
	return( result );
}

/*
 allocate physical memory (RAM), returns physical and linear address
*/
void allocMemBlk( MEMBLK *lpMB )
{
	if (!PhysmemIoctl( 2, &lpMB->size, 4, lpMB, 8 ))
	{
		FATAL( "Couldn't allocate physical memory buffer" );
	}
}

/*
 free physical memory block
*/
void freeMemBlk( MEMBLK *lpMB )
{
	PhysmemIoctl( 3, &lpMB->LinAddr, 4, NULL, 0 );

	lpMB->LinAddr = NULL;
	lpMB->PhysAddr = NULL;
	lpMB->size = 0;
}

/*
 map device I/O memory into linear (paged) memory
*/
void mapMemBlk( MEMBLK *lpMB )
{
	if (!PhysmemIoctl( 1, &lpMB->PhysAddr, 8, &lpMB->LinAddr, 4 ))
	{
		lpMB->LinAddr = NULL;
	}
}

static const char* getCFKey(char *filename,const char* section, const char* key,
const char* default_value, bool create_if_not_found);
static unsigned long getCFKey(char *filename,const char* section, const char* key,
unsigned long default_value, bool create_if_not_found);
static bool getCFKeyBool(char *filename,const char* section, const char* key,
bool default_value, bool create_if_not_found);


static void setCFKey(char *filename,const char* section, const char* key, const char* value);
static void setCFKey(char *filename,const char* section, const char* key, unsigned long value);
static void setCFKeyBool(char *filename,const char* section, const char* key, bool value);
static HMENU createMenu(void);


HWND				hWnd;				// surface window
HMENU				g_hMenu;

bool isWindowed;
static BTxxx* bt = 0;
static CpuInfo* cpu_info = 0;
static bool man_pol_invert = false;
bool debug_mode = false;
static bool test_toggled = false;
static bool lock_it = false;
static int lock_pll;
static int signal_source;
int hsync_extra=0;
static bool stop_decoder = false;

static bool vsync_change_busy = false;
static bool vsync_search_forced = false;

bool always_on_top = true;
bool aspect_ratio = true;
bool use_double_buffering = true;

static long show_help_timeout;

static long next_save_bmp_time = LONG_MAX;
static long save_bitmap_delay;


static VirtualDecoder* decoders[50];
static int nbr_decoders = 0;
static VirtualDecoder* active_decoder = NULL;
static int active_decoder_index = -1;

static LPDIRECTSOUND lpds = NULL;
static LPDIRECTSOUNDBUFFER lpDsb;

void addDecoder(VirtualDecoder* decoder)
{
	if (nbr_decoders >= 50)
   	return;
	decoders[nbr_decoders++] = decoder;
}

void deleteDecoders(void)
{
	for (int t = 0; t < nbr_decoders; t++)
	{
		delete decoders[t];
	}
}


static char* lock_modes[1] = {"X-Lock"};
static int auto_lock_mode = 0;

static int norm_pll_freq = 35468934;
static int dec_pll_freq =  D_PLL_FREQ;		

static int nbr_vsync_errors = 100;
char line[256];
char line2[256];

static char* auto_pol_mode_descr[1] = { "Off"};
static int auto_pol_mode = 0;	// 0 OFF 1 LINE 2 +
static bool polarity_invert = false;

static struct
{
	int x;
	int y;
	int level;
} pol_param[3] = { { 0, 0, 0}, { 1631+374, -1, 4}, { -55+374, 29, 30 }};

static bool pol_debug_mode = false;

static bool decode_sound= false;

MEMBLK				framebuf = { NULL, NULL, 	676*1024};	// single-frame-buffer
MEMBLK				myProg   = { NULL, NULL,   2*7*1024 };	// RISC video program

//static unsigned char* raw_data_buf;

static void buildRisc(void);

static void setModeRaw(void);
static void findLockStartOffImage(unsigned char *membase, int &v_offset, int &h_offset);

int file(const char* filename);


//static BOOL initSound(void);
static void exitSound(void);
static BOOL writeSound(LPBYTE lpbSoundData, DWORD dwSoundBytes);



static void setDecodeMode(int new_mode)
{
	while(true)
	{
		if (new_mode < 0 || new_mode >= nbr_decoders)
			new_mode = 0;

		if (decoders[new_mode]->usesMMX() && !cpu_info->hasMMX())
			new_mode++;	// Volgende nemen
		else
			break;
	}

	active_decoder = decoders[new_mode];
	active_decoder_index = new_mode;

	vsync_change_busy = false;		// TODO ???????????,

	if (bt->getType() != 0)
	{
   		if (active_decoder->useVBI())
		{
   	 		setModeRaw();
		}
	}

	DdrawsetSrcSize(active_decoder->getOutWidth(),active_decoder->getOutHeight());

	for (int t = 0; t < nbr_decoders; t++)
	{
		CheckMenuItem(g_hMenu, IDM_DECODE_MODE+t, 
		  (decoders[t]==active_decoder)?MFS_CHECKED:MFS_UNCHECKED);
	}
}


LRESULT CALLBACK WindowProc( HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	char line[256];

	switch (msg)
	{
		case WM_SIZE:
		case WM_MOVE:
			if (isWindowed)
			{
				DdrawWindowChanged();
	      		if (!use_double_buffering)
   	      			DdrawsetSrcSize(-1,-1);
			}
      		break;

		case WM_EXITSIZEMOVE:
			if (isWindowed && aspect_ratio)
			{
				DdrawCheckAspectRatio();
				return(0L);
			}
      		break;

		case WM_PAINT:
			if (isWindowed)
	        	DdrawCopyBackToFront();
      		break;

		case WM_COMMAND:
      		switch (LOWORD(wParam))
			{
				case IDM_SHOW_DEBUG:
            		debug_mode = !debug_mode;
        			CheckMenuItem(g_hMenu, IDM_SHOW_DEBUG,
						(debug_mode)?MFS_CHECKED:MFS_UNCHECKED);
            		return 0L;

				case IDM_MANUAL_INVERT:
           			man_pol_invert = !man_pol_invert;
        			CheckMenuItem(g_hMenu, IDM_MANUAL_INVERT,
					  (man_pol_invert)?MFS_CHECKED:MFS_UNCHECKED);
            		return 0L;

				case IDM_TOGGLE_FULLSCREEN:
            		isWindowed = !isWindowed;
					DdrawChangeCoopLevel(isWindowed);
            		return 0L;

				case IDM_ALWAYS_ON_TOP:
           			always_on_top = !always_on_top;
					if (!use_double_buffering)
               			always_on_top = true;
        				CheckMenuItem(g_hMenu, IDM_ALWAYS_ON_TOP,
							(always_on_top)?MFS_CHECKED:MFS_UNCHECKED);
						DdrawsetSrcSize(-1, -1);
            		return 0L;

				case IDM_USE_DOUBLE_BUFFERING:
           			use_double_buffering = !use_double_buffering;
        			CheckMenuItem(g_hMenu, IDM_USE_DOUBLE_BUFFERING,
						(use_double_buffering)?MFS_CHECKED:MFS_UNCHECKED);
            		if (!use_double_buffering && !always_on_top)
	              		WindowProc(hwnd, WM_COMMAND, IDM_ALWAYS_ON_TOP, 0);
					DdrawsetSrcSize(-1, -1);               
            		return 0L;

				case IDM_ASPECT_RATIO:
           			aspect_ratio = !aspect_ratio;
        			CheckMenuItem(g_hMenu, IDM_ASPECT_RATIO,
						(aspect_ratio)?MFS_CHECKED:MFS_UNCHECKED);
					if (aspect_ratio)
						DdrawCheckAspectRatio();
            		return 0L;

				case IDM_CLI:
					disable_ints = !disable_ints;
        			CheckMenuItem(g_hMenu, IDM_CLI,
						(disable_ints)?MFS_CHECKED:MFS_UNCHECKED);
            		return 0L;

				case IDM_KEY_HELP:
               			char buf[1024];

						strcpy(buf,"Help\r\r");
						strcat(buf,"F1			-   This box\r");

						strcat(buf,"\rDecoding and locking keys\r\r");

						strcat(buf,"F5			-   Hsync left\r");
						strcat(buf,"F6			-   Hsync right\r");
						strcat(buf,"F7/F8			-   Adjust colorburst width\r");
						strcat(buf,"F12			-   Show info\r");
						strcat(buf,"I			-   Reset PLL\r");
						strcat(buf,"L			-   Start locking\r");
						strcat(buf,"LEFT			-   Adjust PLL -left\r");
						strcat(buf,"RIGHT			-   Adjust PLL -right\r");
						strcat(buf,"UP			-   Adjust PLL -up\r");
						strcat(buf,"DOWN			-   Adjust PLL -down\r");

						strcat(buf,"\rScreen size and position\r\r");
						strcat(buf,"ENTER			-   Fullscreen toggle\r");
						strcat(buf,"				    (disables ints when checked)\r");
						strcat(buf,"SHIFT+LEFT/RIGHT	-   Stretch screen x\r");
						strcat(buf,"SHIFT+UP/DOWN		-   Stretch screen y\r");
						strcat(buf,"R				-   Reset stretch\r");
						strcat(buf,"CTRL+UP/DOWN		-   Drawing start y\r");

						strcat(buf,"\rColor adjustments\r\r");
						strcat(buf,"A			-   Automatic luma adjust toggle\r");
						strcat(buf,"Q/W			-   Automatic luma adjust start offset\r");
						strcat(buf,"F3			-   Chroma invert\r");
						strcat(buf,"F4			-   Luma invert\r");
						strcat(buf,"HOME/END		-   Contrast\r");
						strcat(buf,"PGUP/PGDN		-   Brightness\r");
						strcat(buf,"INS/DEL			-   Saturation\r");

						strcat(buf,"\rQuick exit\r\r");
						strcat(buf,"ESC			-   Quit\r");

	         			MessageBox(hwnd, buf, "Keyboard help",MB_OK | MB_ICONQUESTION);
					return 0L;
         		case IDM_SYSTEM_INFO:

						sprintf(buf, "%s chip found\n\n%s", 
							bt->getTypeName(), cpu_info->getInfo());
	         				MessageBox(hwnd, buf, "System Info",
        					MB_OK | MB_ICONINFORMATION | MB_APPLMODAL );
					return 0L;

         		case IDM_ABOUT:
         			MessageBox(hwnd,
						"Decoder V5 Overlay\r\r\r"
						"\r*****\r"
						"\rE-Mail: accelerated_one@hotmail.com\r"
						"", "About...",
        				MB_OK | MB_ICONINFORMATION | MB_APPLMODAL );
					return 0L;


				case IDM_SVIDEO:
           				CheckMenuItem(g_hMenu, IDM_SVIDEO,MFS_CHECKED);
           				CheckMenuItem(g_hMenu, IDM_TUNER,MFS_UNCHECKED);
           				CheckMenuItem(g_hMenu, IDM_COMPOSITE,MFS_UNCHECKED);
						signal_source = VIDEO_SVIDEO;
						bt->setVideoSource( signal_source );
            		return 0L;

				case IDM_TUNER:
           				CheckMenuItem(g_hMenu, IDM_SVIDEO,MFS_UNCHECKED);
           				CheckMenuItem(g_hMenu, IDM_TUNER,MFS_CHECKED);
           				CheckMenuItem(g_hMenu, IDM_COMPOSITE,MFS_UNCHECKED);
						signal_source = VIDEO_TUNER;
						bt->setVideoSource( signal_source );
            		return 0L;

				case IDM_COMPOSITE:
           				CheckMenuItem(g_hMenu, IDM_SVIDEO,MFS_UNCHECKED);
           				CheckMenuItem(g_hMenu, IDM_TUNER,MFS_UNCHECKED);
           				CheckMenuItem(g_hMenu, IDM_COMPOSITE,MFS_CHECKED);
						signal_source = VIDEO_COMPOSITE;
						bt->setVideoSource( signal_source );
            		return 0L;

				case IDM_EXIT:
					if (saving==1) close(fd);
					PostQuitMessage( 0 );
					return 0L;

				default:
					if (LOWORD(wParam) >= IDM_DECODE_MODE && LOWORD(wParam) < IDM_DECODE_MODE + nbr_decoders) {
						setDecodeMode(LOWORD(wParam)-IDM_DECODE_MODE);
						return 0L;
						}
           		break;
		}

		case WM_KEYDOWN:
			switch (wParam)
			{

			// configurations save

					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':
					case '9':
					case '0':

					sprintf(line,"Decoder 4.in%c",wParam);

				if (GetKeyState(VK_CONTROL) & 0xFF00) {
					setCFKeyBool(line,"GENERAL", "MANUAL_POLARITY_INVERT", man_pol_invert);
					setCFKeyBool(line,"GENERAL", "ALWAYS_ON_TOP", always_on_top);
					setCFKeyBool(line,"GENERAL", "ASPECT_RATIO", aspect_ratio);
					setCFKeyBool(line,"GENERAL", "USE_DOUBLE_BUFFERING", use_double_buffering);
					setCFKeyBool(line,"GENERAL", "ADJUST_LUMA_LEVEL", adjust_luma_level);
					setCFKeyBool(line,"GENERAL", "DISABLE_INTS", disable_ints);
					setCFKey(line,"GENERAL", "X_BORDER", border_x);
					setCFKey(line,"GENERAL", "Y_BORDER", border_y);
					setCFKey(line,"GENERAL", "START_Y2", start_y2);
					setCFKey(line,"GENERAL", "BRIGHTNESS", color_cfg[0].brightness);
					setCFKey(line,"GENERAL", "CONTRAST", color_cfg[0].contrast);
					setCFKey(line,"GENERAL", "SATURATION", color_cfg[0].saturation);
					setCFKey(line,"GENERAL", "BRIGHTNESS2", color_cfg[1].brightness);
					setCFKey(line,"GENERAL", "CONTRAST2", color_cfg[1].contrast);
					setCFKey(line,"GENERAL", "SATURATION2", color_cfg[1].saturation);
					setCFKey(line,"GENERAL", "lladjust2", lladjust2);
					setCFKey(line,"GENERAL", "hsync_extra", hsync_extra);

					break;
				}

				if (GetKeyState(VK_SHIFT) & 0xFF00) {
					man_pol_invert = getCFKeyBool(line,"GENERAL", "MANUAL_POLARITY_INVERT", false, true);
					always_on_top = getCFKeyBool(line,"GENERAL", "ALWAYS_ON_TOP", true, true);
					aspect_ratio = getCFKeyBool(line,"GENERAL", "ASPECT_RATIO", true, true);
					use_double_buffering = getCFKeyBool(line,"GENERAL", "USE_DOUBLE_BUFFERING", true, true);
					adjust_luma_level = getCFKeyBool(line,"GENERAL", "ADJUST_LUMA_LEVEL", true, true);
					disable_ints=getCFKeyBool(line,"GENERAL", "DISABLE_INTS", true, true);
					border_x=getCFKey(line,"GENERAL", "X_BORDER", true, true);
					border_y=getCFKey(line,"GENERAL", "Y_BORDER", true, true);
					start_y2=getCFKey(line,"GENERAL", "START_Y2", true, true);
					color_cfg[0].brightness=getCFKey(line,"GENERAL", "BRIGHTNESS", true,true);
					color_cfg[0].contrast=getCFKey(line,"GENERAL", "CONTRAST", true,true);
					color_cfg[0].saturation=getCFKey(line,"GENERAL", "SATURATION", true,true);
					color_cfg[1].brightness=getCFKey(line,"GENERAL", "BRIGHTNESS2", true,true);
					color_cfg[1].contrast=getCFKey(line,"GENERAL", "CONTRAST2", true,true);
					color_cfg[1].saturation=getCFKey(line,"GENERAL", "SATURATION2", true,true);
					lladjust2=getCFKey(line,"GENERAL", "lladjust2", true, true);
					hsync_extra=getCFKey(line,"GENERAL", "hsync_extra", true, true);
					
					DdrawsetSrcSize(active_decoder->getOutWidth(),active_decoder->getOutHeight());

					break;
				}

				case 'Z':
					quality=quality^1;
					if (quality) decWidth=720; else decWidth=360; 
					DdrawsetSrcSize(decWidth,280);

					break;


// testing
		case 'N':
      	lladjust4--;
		bt->setWordSwap(false);
         break;
		case 'M':
      	lladjust4++;
		bt->setWordSwap(true);
         break;

// save video file //

				// start saving
				case 'S':
					if (saving==0) {
						saving=1;
						save_y=0;
						frame=0;
						if (fd) close(fd);
						unlink("c:\\raw.dat");
						fd = open("c:\\raw.dat", O_CREAT|O_WRONLY|O_BINARY,S_IREAD|S_IWRITE);
						} else { 
						saving=0;
						close(fd); 
						}
					break;
				// start playing
				case 'P':
					if (fd) close(fd);
					if (playing==0) {
						playing=1; 
						fd = open("c:\\raw.dat", O_RDONLY|O_BINARY,S_IREAD);
						} else {
						playing=0;
						close(fd);
						}
					break;

				// resolution
				case 'X':
					break;

				case VK_LEFT:
            		if (GetKeyState(VK_SHIFT) & 0xFF00)
					{
	            		border_x--;
						if (border_x<0) border_x=0;
						DdrawsetSrcSize(active_decoder->getOutWidth(),active_decoder->getOutHeight());
					}
					else
					{
						bt->setPllFrequency(dec_pll_freq-20);  // was 20
   						dec_pll_freq = bt->getPllFrequency();
					}
					break;

				case VK_RIGHT:
            		if (GetKeyState(VK_SHIFT) & 0xFF00)
					{
	            		border_x++;
						if (border_x>active_decoder->getOutWidth()-1) border_x=active_decoder->getOutWidth()-1;
						DdrawsetSrcSize(active_decoder->getOutWidth(),active_decoder->getOutHeight());
					}
					else
					{
						bt->setPllFrequency(dec_pll_freq + 20);   // was 20
   						dec_pll_freq = bt->getPllFrequency();
					}
					break;
				
				case VK_UP:
            		if (GetKeyState(VK_CONTROL) & 0xFF00)
					{
	            		start_y2++;
						if ((border_y+start_y2)>active_decoder->getOutHeight()-1) start_y2--; else
						DdrawsetSrcSize(active_decoder->getOutWidth(),active_decoder->getOutHeight());
					} else {
            		if (GetKeyState(VK_SHIFT) & 0xFF00)
					{
	            		border_y++;
						if ((border_y+start_y2)>active_decoder->getOutHeight()-1) border_y--; else
						DdrawsetSrcSize(active_decoder->getOutWidth(),active_decoder->getOutHeight());
					}
					else
					{
						if (move_cnt==0) move_y=2;
					}
					}
					break;
				
				case VK_DOWN:
            		if (GetKeyState(VK_CONTROL) & 0xFF00)
					{
	            		start_y2--;
						if (start_y2<0) start_y2=0; else
						DdrawsetSrcSize(active_decoder->getOutWidth(),active_decoder->getOutHeight());
					} else {
            		if (GetKeyState(VK_SHIFT) & 0xFF00)
					{
	            		border_y--;
						if (border_y<0) border_y=0; else
						DdrawsetSrcSize(active_decoder->getOutWidth(),active_decoder->getOutHeight());
					}
					else
					{
						if (move_cnt==0) move_y=-2;
					}
					}
					break;

				case VK_RETURN:
              		WindowProc(hwnd, WM_COMMAND, IDM_TOGGLE_FULLSCREEN, 0);
					break;

				case VK_F1:
			        WindowProc(hwnd, WM_COMMAND, IDM_KEY_HELP, 0);
					break;

	            case VK_F4:
			        WindowProc(hwnd, WM_COMMAND, IDM_MANUAL_INVERT, 0);
					break;

				case VK_F5:
            		hsync_extra++;
					break;

				case VK_F12:
					WindowProc(hwnd, WM_COMMAND, IDM_SHOW_DEBUG, 0);
					break;

				case VK_F6:
					hsync_extra--;
					break;

				case VK_F7:
            		VirtualDecoder::decColorBurstWidth();
					break;

				case VK_F8:
            		VirtualDecoder::incColorBurstWidth();
					break;

				case 'I':
					dec_pll_freq = D_PLL_FREQ;
					bt->setPllFrequency(dec_pll_freq);
					break;

				case 'L':
           			lock_it = !lock_it;
					lock_pll = bt->getPllFrequency();
					break;

				case VK_ESCAPE:
					if (saving==1) close(fd);
					PostQuitMessage( 0 );
					return(0);

				default:
					active_decoder->processKey(wParam);
					break;
			}
			break;

		case WM_DESTROY:
			if (saving==1) close(fd);
			PostQuitMessage( 0 );
			return(0);
	}
	return DefWindowProc( hwnd, msg, wParam, lParam );
}


static void adjustPLL(int v_offset, int h_offset)
{
	static int last_h_offset;
	static int vertical_total = bt->getVerticalTotal();

	if (auto_lock_mode == 2 &&
     (v_offset < -2 || v_offset > 2 || vsync_search_forced))
	{
   		if (vsync_search_forced)
		{
      		vsync_search_forced = false;
      		nbr_vsync_errors = 1000;
			vsync_change_busy = false;
		}

   		if (++nbr_vsync_errors < 30)
      		return;

		if (!vsync_change_busy)
		{
			vsync_change_busy = true;
			if (bt->getType() == BT8780 || bt->getType() == BT8781 || bt->getType() == BT8782 || bt->getType() == BT8783 || bt->getType() == BT8784 || bt->getType() == BT879)
				bt->setVerticalTotal(vertical_total + 1);
			else
				bt->setPllFrequency(dec_pll_freq - 56700);
		}
     	return;
	}

	nbr_vsync_errors = 0;
	if (vsync_change_busy)
	{
		vsync_change_busy = false;
			if (bt->getType() == BT8780 || bt->getType() == BT8781 || bt->getType() == BT8782 || bt->getType() == BT8783 || bt->getType() == BT8784 || bt->getType() == BT879)
			bt->setVerticalTotal(vertical_total);
		else
    		bt->setPllFrequency(dec_pll_freq);
	}

	int step = (abs(h_offset) > 100)?100:10;
	// Fine tuning (left <-> right)
	if (h_offset > 0)
	{
		// dec_pll_freq kleiner maken
		if (h_offset >= last_h_offset)	// Nog niet beter ?
       		dec_pll_freq -= step;
  	}
	else if (h_offset < 0)
	{	
  		// dec_pll_freq groter maken
		if (h_offset <= last_h_offset)	// Nog niet beter ?
			dec_pll_freq += step;
	}
	else
  	{
   		dec_pll_freq = bt->getPllFrequency();
	}

	if (auto_lock_mode == 0)
	{	
   		if (!lock_it)
      		return;

  		if (dec_pll_freq > lock_pll + 20)
	      	dec_pll_freq = lock_pll + 20;
     	else if (dec_pll_freq < lock_pll - 20)
		  	dec_pll_freq = lock_pll - 20;
	}

	bt->setPllFrequency(dec_pll_freq);

	last_h_offset = h_offset;
}


int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrev, LPSTR szCmdLine, int sw )
{
	MSG msg;

	int x,y,z;

	y=0;

	cpu_info = new CpuInfo();
	bt = new BTxxx();

	allocMemBlk( &myProg );				// allocate RAM for RISC programs
	allocMemBlk( &framebuf );			// allocate RAM for frame buffer


	// ***** Optimizer comments:								*****
	// ***** Manual memory align								*****
	// *****													*****
	x=(int)framebuf.PhysAddr;
	frameaddr=(x/128)*128;
	frameadd=x-frameaddr;

	signal_source = VIDEO_TUNER;

	if (bt->getType() != 0)
	{
		bt->softwareReset();
   		Sleep(100);
		bt->scalerInit();
		bt->setCrystal( XT0 );					// base for PLL or XT1 for BT848
		bt->setPllFrequency(35437235);
		bt->setPllEnabled(true);				// enable PLL
		bt->setVideoSource( signal_source );				// select tvtuner
		bt->setVideoFormat( VIDEOFORMAT_PAL_BDGHI);		// set PAL video
		bt->setComponentVideo( false );				// PAL is composite
		bt->setDropEvenField( true);			// align fields
		bt->setDropRate(0);								// don't drop any frames
		bt->setAnalogWindow( 190, 914, 2, 625 );// setup scaler
		bt->setFieldSize(384,288);
		//bt->setAGCDelay(0);
		//bt->setAdaptiveAGC(true);
		//bt->setBurstDelay(1);
		//bt->setChromaAGC(true);
		//bt->setLumaADC(true);
		//bt->setContrast(128);
		//bt->setChromaComb(true);
		//bt->setLowColorAutoRemoval(true);
	}


	// Read config file

	char line[256];
	strcpy(line,"Decoder 4.in0");

					man_pol_invert = getCFKeyBool(line,"GENERAL", "MANUAL_POLARITY_INVERT", false, true);
					always_on_top = getCFKeyBool(line,"GENERAL", "ALWAYS_ON_TOP", true, true);
					aspect_ratio = getCFKeyBool(line,"GENERAL", "ASPECT_RATIO", true, true);
					use_double_buffering = getCFKeyBool(line,"GENERAL", "USE_DOUBLE_BUFFERING", true, true);
					disable_ints=getCFKeyBool(line,"GENERAL", "DISABLE_INTS", true, true);
					adjust_luma_level = getCFKeyBool(line,"GENERAL", "ADJUST_LUMA_LEVEL", true, true);
					border_x=getCFKey(line,"GENERAL", "X_BORDER", true, true);
					border_y=getCFKey(line,"GENERAL", "Y_BORDER", true, true);
					start_y2=getCFKey(line,"GENERAL", "START_Y2", true, true);
					color_cfg[0].brightness=getCFKey(line,"GENERAL", "BRIGHTNESS", true,true);
					color_cfg[0].contrast=getCFKey(line,"GENERAL", "CONTRAST", true,true);
					color_cfg[0].saturation=getCFKey(line,"GENERAL", "SATURATION", true,true);
					color_cfg[1].brightness=getCFKey(line,"GENERAL", "BRIGHTNESS2", true,true);
					color_cfg[1].contrast=getCFKey(line,"GENERAL", "CONTRAST2", true,true);
					color_cfg[1].saturation=getCFKey(line,"GENERAL", "SATURATION2", true,true);
					lladjust2=getCFKey(line,"GENERAL", "lladjust2", true, true);
					hsync_extra=getCFKey(line,"GENERAL", "hsync_extra", true, true);



	// register Window class
	WNDCLASS wc;
	HICON r;
	memset(&wc, 0, sizeof(WNDCLASSEX));
	wc.lpszClassName = AppTitle;
	wc.lpfnWndProc = WindowProc;
	wc.style = CS_VREDRAW | CS_HREDRAW;
	wc.hInstance = hInst;
	//r=LoadStandardIcon(hInst, MAKEINTRESOURCE(IDI_HAND));
	//wc.hIconSm = r;
	//wc.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_MAIN_ICON));
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	//wc.lpszMenuName = MAKEINTRESOURCE(IDR_MENU);
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	//wc.cbSize=sizeof(WNDCLASSEX);
	RegisterClass(&wc);
	
	hWnd = CreateWindowEx( 0,
		AppTitle,
		AppTitle,
		WS_OVERLAPPEDWINDOW,
		0,
		0,
		10,
		10,
		NULL,
		NULL,
		hInst,
		NULL);

	addDecoder(new dukedecoder());

	g_hMenu = createMenu();
	SetMenu(hWnd, g_hMenu);

	char errorbuf[500];
	if (initDdraw(hWnd, errorbuf) < 0)
   		FATAL(errorbuf);
	isWindowed = true;

	setDecodeMode(active_decoder_index);

	ShowWindow(hWnd, sw);
	UpdateWindow(hWnd);

	      	static int prevFrame = -1;


	// 350mhz k6/2 only:
	int max_wait=10000000;

	fid=((unsigned long *)framebuf.LinAddr+2268*240/4);
				waiting=-1;
				do {
					waiting++;
					frame_id=*fid+*(fid+4)+*(fid+8)+*(fid+12);
					if (waiting>max_wait) break;
				} while(frame_id==frame_id_prev);
	frame_id_prev=frame_id;



	// message loop
	while( true )
	{
		if (PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ))
		{
			if (msg.message == WM_QUIT)
				break;

			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else 
		{	
				static long last_time;
           		int v_offset = 0;
           		int h_offset = 0;
				bool invert=false;

				__int64 start_microsec;

				//long tijd= time(0);    

				// ***** Optimizer comments:								*****
				// ***** synchronise frame's DMA transfer and decoding		*****
				// ***** start decoding same time DMA started transfer		*****

				
				waiting=-1;
				do {

				// savefile
				if ((saving==1) && ((frame&1)==1)) {

					lockDisplay();
					s0=(unsigned char *)pixels;
					s0+=save_y*pitch;
					write(fd,s0,360*2);
					unlockDisplay();

					save_y+=1;
					if (save_y==288) save_y=0;
					}

					waiting++;
					frame_id=*fid+*(fid+4)+*(fid+8)+*(fid+12);
					if (waiting>max_wait) break;
				} while((frame_id==frame_id_prev) || (!bt->isDecodeEvenField()));

				start_microsec = getMicroSec();

				if (playing==0) {
					active_decoder->decodeFrame((unsigned char *)(framebuf.LinAddr+frameadd), h_offset+2268, FALSE); 
					} else {
					if ((frame/32)*32==frame) {
						lockDisplay();
							s0=(unsigned char *)pixels;
							for (y=0;y<288;y++) {
									read(fd,s0,360*2);
								s0+=pitch*1;
								}
						unlockDisplay();
						active_decoder->decodeFrame(NULL,-1, invert); 
					}
				//drawText(border_x, border_y,"PLAY", RGB(0, 255, 0));
					}

				DdrawCopyBackToFront();
				frame++;



					if (!lock_it) h_offset = 0;
					findLockStartOffImage((unsigned char *)(framebuf.LinAddr+frameadd), v_offset, h_offset);
					if (lock_it) adjustPLL(v_offset, h_offset);


				if (move_y!=0) {
				if (move_cnt==0) {

			if (bt->getType() == BT8780 || bt->getType() == BT8781 || bt->getType() == BT8782 || bt->getType() == BT8783 || bt->getType() == BT8784 || bt->getType() == BT879)
						{
							bt->setVerticalTotal(bt->getVerticalTotal()+move_y);
						}
						else
						{
							bt->setPllFrequency(dec_pll_freq - 56700*move_y);
	   						dec_pll_freq = bt->getPllFrequency();
						}
						move_cnt=1;

				} else {

					move_cnt--;
					if (move_cnt==0) {
			if (bt->getType() == BT8780 || bt->getType() == BT8781 || bt->getType() == BT8782 || bt->getType() == BT8783 || bt->getType() == BT8784 || bt->getType() == BT879)
						{
							bt->setVerticalTotal(bt->getVerticalTotal()-move_y);
						}
						else
						{
							bt->setPllFrequency(dec_pll_freq + 56700*move_y);
	   						dec_pll_freq = bt->getPllFrequency();
						}
					move_y=0;
					}

					}
					}

				if (auto_lock_mode == 0 && !lock_it)
				{
					/*
		      		drawText(0,0,"Adjust the image position and\n"
						"press 'L' to start locking ...",
     					RGB(0,0,255));
					*/

	               if ((active_decoder->getHSync() != -1) && (!lock_it))
		           {

						int x = active_decoder->convertRawXToScreenX(active_decoder->getHSync());
						if (x >= 0 || x < active_decoder->getOutWidth())
                  		for (int y = 0; y < active_decoder->getOutHeight(); y+=1)
                     		putPixel(x,y,255,0,0);
					}
				}

				if (debug_mode)
				{
					__int64 stop_microsec = getMicroSec();
					int diff_microsec = stop_microsec - start_microsec;

					microsec_cnt++;
					microsec_cnt=microsec_cnt&15;
					microsecs[microsec_cnt]=diff_microsec;
					z=16;
					for (x=0;x<16;x++) {
						z+=microsecs[x];
						}
					z=z>>4;
					microsec_min=z;

              		char buf[500];
					sprintf(info_text_buffer,
						"%d MAX FPS %02d (%d microsec/frame)\n"
						"Voffset %d Hoffset %d (hsync %d)\n"
						"lladjust2 %d\nlockdiff %d\n"
						"PLL %d, frame:%d, wait:%d\n"
						"cb_width %d lladjust4 %d",lladjust4,
						1000000/z, z,
						v_offset, h_offset, active_decoder->getHSync(),
						lladjust2,lock_difference,dec_pll_freq,frame,waiting,
						VirtualDecoder::getColorBurstWidth(), lladjust4);
      			}

		}
/*		else
		{
      		static int y = 10;
			static int dir = 1;

			y += dir;
			if (y < 10 || y > 170)
         		dir = -dir;

	   		clearDisplay();
	   		drawText(30, y,
        	  "No valid BTxxx Chip found !\r\r"
        	  "This program supports BT848,\r"
        	  "BT849, BT878 and BT879 chip\r"
        	  "based capture cards.",
        	  RGB(255, 20, 20));
			DdrawCopyBackToFront();
			Sleep(10);
   		}*/
	}

	
	deleteDecoders();

	uninitDdraw();

	if (bt->getType() != 0)
	{
		bt->setPllFrequency(norm_pll_freq);
   		bt->setTest(1);test_toggled = false;
		bt->setVerticalTotal( 1 );		// disable vertical total
		bt->setCaptureEnabled( false );	// disable capture of both fields
		bt->setFifoEnabled( false );	// disable FIFO unit
		bt->setRiscEnabled( false );	// disable RISC unit
	}

	delete bt;

	freeMemBlk( &framebuf );
	freeMemBlk( &myProg );


	return(0);
}


/*
 Error handler

 display message and file, line where the error occured.
*/
void error_win(char *msg, char *file, int line, int FATAL)
{
	if (file)
	{
		char errout[512];
		sprintf( errout, "Error (%s line %d): %s\n", file, line, msg );
		msg = errout;
	}

	ShowCursor(true);
	uninitDdraw();

	MessageBox( NULL, msg, AppTitle, MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL );

   if (FATAL)
   {
		if (hWnd)
  			DestroyWindow( hWnd );
		ExitProcess(1);		// Win32's exit()
   }
}




static void setModeRaw(void)
{
	int i, membase, PC;

	bt->setCaptureEnabled( false );				// disable capture
	bt->setFifoEnabled( false );	// disable FIFO unit
	bt->setRiscEnabled( false );	// disable RISC unit

	membase = (int) framebuf.PhysAddr+frameadd;
	PC = 0;

	myProg.LinAddr[ PC++ ] = RISC_SYNC( RISC_RESYNC, RISC_SC_VRE );	// even field
	myProg.LinAddr[ PC++ ] = 0;
	myProg.LinAddr[ PC++ ] = RISC_SYNC( 0, RISC_SC_FM1 );			// raw data
	myProg.LinAddr[ PC++ ] = 0;

	for (i=0; i < 674; i++)
	{
		myProg.LinAddr[ PC++ ] = RISC_WRITE( RISC_SOL|RISC_EOL, 1024 );// 1 KB ..
		myProg.LinAddr[ PC++ ] = membase;				// .. here
		membase += 1024;
	}

	myProg.LinAddr[ PC++ ] = RISC_JUMP(RISC_SOL|RISC_EOL);	// loop to start (next frame)
	myProg.LinAddr[ PC++ ] = (int) &myProg.PhysAddr[0];

	bt->setTest(239);test_toggled=true;  	// patch test register (undocumented!)
	bt->setVerticalTotal( 625 );					// enable vertical total

	bt->setColorFormat(COLORFORMAT_Raw8X);	// output format is RAW samples
  	bt->setPllFrequency(dec_pll_freq);		// 2268 bytes/line

	bt->setExtFrame( true );						// extend capture size

	bt->setRiscIPC( (unsigned int) myProg.PhysAddr );	// set RISC program counter
	bt->setRiscEnabled( true );					// enable RISC processor
	bt->setFifoEnabled( true );					// enable FIFO processor
	bt->setCaptureEvenEnabled( true );			// enable capture of even and odd fields
}




//this's good lock
static void findLockStartOffImage(unsigned char *membase, int &v_offset, int &h_offset)
{
	h_offset = v_offset = 0;
	unsigned char* ptr;
	int now,max=0,maxx=160;

  	for (register int x = 220; x > 120;x--)
   {
   	ptr = membase;
	ptr+=2268*287;
      int nbr = 0;
		for (register int y=0; y < 288; y+=1)
      {
         now = abs((ptr[x]) - (ptr[x+5]));
         now -= abs((ptr[x]) - (ptr[x-5]));
         nbr += now;
         ptr -= 2268;
      }
		if (nbr>max) {
			max=nbr;
			maxx=x;
			}
   }

	active_decoder->setHSync(maxx);
	h_offset = maxx-163+hsync_extra*0;
	h_offset=(h_offset*256)/192;

	lock_x=maxx;
	lock_difference=max;
}





/*******************************************************************************
**
**			Config file functions
**
*******************************************************************************/

static const char* getCFKey(char *filename,const char* section, const char* key,
  const char* default_value, bool create_if_not_found)
{
   char buf[600];
   char mykey[300];
   strcpy(mykey, key);
   strcat(mykey, "=");
	int mykeylen = strlen(mykey);

   FILE* cf = fopen(filename, "rb");
   if (cf != 0)
   {
		// De section zoeken
		while(fgets(buf, 600, cf) != 0)
		{
		   if (buf[0] == '[' && strncmp(buf+1, section, strlen(section)) == 0)
			{
				while(fgets(buf, 600, cf) != 0 && buf[0] != '[')
				{
            	if (strncmp(mykey, buf, mykeylen) == 0)
			    	{
						// We verwijderen de newline op het einde
						int len = strlen(buf);
						if (buf[len - 1] == '\n')
			    			buf[len - 1]= '\0';
						// Eventuele <CR> verwijderen
						if (buf[len - 2] == '\r')
			    			buf[len - 2]= '\0';

						fclose(cf);
						return(buf+mykeylen);	// Ok !
            	}
				}
			}
		}

		fclose(cf);
	}

   if (create_if_not_found)
		setCFKey(filename,section, key, default_value);

	return(default_value);
}

/*
** Als *value = '\0' -> delete key
*/
static void setCFKey(char *filename,const char* section, const char* key, const char* value)
{
	char buf1[600];
	char buf2[600];
   int  value_done = 0;
   char mykey[300];
   strcpy(mykey, key);
   strcat(mykey, "=");
   int mykeylen = strlen(mykey);
   int section_found = 0;

	// De vorige .cfg file wordt een .bak file
   unlink("temp");					// Eventueel
   rename(filename, "temp");	// Eventueel

   FILE* newf = fopen(filename, "wb");
   if (newf == 0)
   	return;		// SHiiiiiiiiiiit
	FILE* oldf = fopen("temp", "rb");

	if (oldf)
   {
		while(fgets(buf1, 600, oldf) != 0)
		{
      	fputs(buf1, newf);
	    	if (!value_done && buf1[0] == '[' &&
	        strncmp(buf1+1, section, strlen(section)) == 0)
	    	{
				// We komen hier enkel als value_done == 0 !
				section_found = 1;

				// Section gevonden, we zoeken de key
				while(fgets(buf1, 600, oldf) != 0)
				{
		    		if (buf1[0] == '[' ||
		      	  strncmp(mykey, buf1, mykeylen) == 0)
		    		{
						// Einde van de sectie of key gevonden
						if (*value != '\0')
						{
			    			// We schrijven de nieuwe key
			    			sprintf(buf2, "%s=%s\r\n", key, value);
			    			fputs(buf2, newf);
						}

						value_done = 1;

						if (buf1[0] == '[')
						{
			    			sprintf(buf2, "\r\n");// Lege lijn voor de section
			    			fputs(buf2, newf);
			    			fputs(buf1, newf);	// Nieuwe sectie schrijven
						}
						break;			// Nu komen we hier nooit meer
					}

		    		if (buf1[0] != '\r' && buf1[0] != '\n')
						fputs(buf1, newf);  // Geen lege lijnen boven de key
				}
			}
		}

		fclose(oldf);
	}

   if (!value_done && *value != '\0')
   {
		if (!section_found)
		{
      	// We voegen de section toe
      	sprintf(buf1, "[%s]\r\n", section);
	    	fputs(buf1, newf);
      }
		// We voegen de key toe
		sprintf(buf1, "%s=%s\r\n", key, value);
		fputs(buf1, newf);
	}

   fclose(newf);
}


static unsigned long getCFKey(char *filename,const char* section, const char* key,
  unsigned long default_value, bool create_if_not_found)
{
	char buf[30];
   sprintf(buf, "%ld", default_value);
   return(strtoul(getCFKey(filename,section, key, buf, create_if_not_found), NULL, 10));
}

static void setCFKey(char *filename,const char* section, const char* key, unsigned long value)
{
	char buf[30];
   sprintf(buf, "%ld", value);
   setCFKey(filename,section, key, buf);
}


static bool getCFKeyBool(char *filename,const char* section, const char* key,
  bool default_value, bool create_if_not_found)
{
   const char* ret = getCFKey(filename,section, key, (default_value)?"TRUE":"FALSE", create_if_not_found);
   if (strcmp(ret, "TRUE") == 0)
   	return(true);
   return(false);
}


static void setCFKeyBool(char *filename,const char* section, const char* key, bool value)
{
   setCFKey(filename,section, key, (value)?"TRUE":"FALSE");
}



static HMENU createMenu(void)
{
	int t;
	MENUITEMINFO menuitem;
	HMENU submenu, subsubmenu;
	HMENU menu = CreateMenu();

	memset(&menuitem, 0, sizeof(menuitem));
	menuitem.cbSize = sizeof(menuitem);

	// File menu
	submenu = CreatePopupMenu();
	/*
	menuitem.fMask = MIIM_TYPE|MIIM_ID;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "Snapshot\tF9";
	menuitem.wID = IDM_SNAPSHOT;
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 0, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_ID;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "Snapshots\tShift+F9";
	menuitem.wID = IDM_SNAPSHOTS;
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 1, TRUE, &menuitem);
	menuitem.fMask = MIIM_TYPE;
	menuitem.fType = MFT_SEPARATOR;
	InsertMenuItem(submenu, 2, TRUE, &menuitem);
*/

	menuitem.fMask = MIIM_TYPE|MIIM_ID;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "E&xit";
	menuitem.wID = IDM_EXIT;
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 0, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_SUBMENU;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "&File";
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	menuitem.hSubMenu = submenu;
	InsertMenuItem(menu, IDM_FILE_SUBMENU_POS, TRUE, &menuitem);

	// Decode mode menu
	submenu = CreatePopupMenu();
	subsubmenu = CreatePopupMenu();
	for (t = 0; t < nbr_decoders; t++)
	{
		menuitem.fMask = MIIM_TYPE|MIIM_ID;
		menuitem.fType = MFT_STRING|MFT_RADIOCHECK;
		menuitem.dwTypeData = (char*)decoders[t]->getDescription();
		menuitem.wID = IDM_DECODE_MODE+t;
		menuitem.cch = strlen((char*)menuitem.dwTypeData);
		InsertMenuItem(subsubmenu, t, TRUE, &menuitem);

		if (decoders[t]->usesMMX() && !cpu_info->hasMMX())
			EnableMenuItem(subsubmenu, t, MF_BYPOSITION|MF_GRAYED);
	}
	menuitem.fMask = MIIM_TYPE|MIIM_SUBMENU;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "&Mode";
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	menuitem.hSubMenu = subsubmenu;
	InsertMenuItem(submenu, 0, TRUE, &menuitem);
/*
	subsubmenu = CreatePopupMenu();
	for (t = 0; t < 3; t++)
	{
		menuitem.fMask = MIIM_TYPE|MIIM_ID|MIIM_STATE;
		menuitem.fType = MFT_STRING|MFT_RADIOCHECK;
		menuitem.fState = (t==auto_pol_mode)?MFS_CHECKED:MFS_UNCHECKED;
		menuitem.dwTypeData = auto_pol_mode_descr[t];
		menuitem.wID = IDM_AUTO_INVERT_NONE+t;
   		menuitem.cch = strlen((char*)menuitem.dwTypeData);
		InsertMenuItem(subsubmenu, t, TRUE, &menuitem);
	}
	menuitem.fMask = MIIM_TYPE|MIIM_SUBMENU;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "Auto &polarity";
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	menuitem.hSubMenu = subsubmenu;
	InsertMenuItem(submenu, 1, TRUE, &menuitem);
*/
	subsubmenu = CreatePopupMenu();
	for (t = 0; t < 1; t++)
	{
		menuitem.fMask = MIIM_TYPE|MIIM_ID|MIIM_STATE;
		menuitem.fType = MFT_STRING|MFT_RADIOCHECK;
		menuitem.fState = (t==auto_lock_mode)?MFS_CHECKED:MFS_UNCHECKED;
		menuitem.dwTypeData = lock_modes[t];
		menuitem.wID = IDM_AUTO_LOCK_MODE1+t;
   		menuitem.cch = strlen((char*)menuitem.dwTypeData);
		InsertMenuItem(subsubmenu, t, TRUE, &menuitem);
	}
	menuitem.fMask = MIIM_TYPE|MIIM_SUBMENU;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "&Auto lock";
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	menuitem.hSubMenu = subsubmenu;
	InsertMenuItem(submenu, 2, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_ID|MIIM_STATE;
	menuitem.fType = MFT_STRING;
	menuitem.fState = (man_pol_invert)?MFS_CHECKED:MFS_UNCHECKED;
	menuitem.dwTypeData = "&Invert\tF4";
	menuitem.wID = IDM_MANUAL_INVERT;
  	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 3, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_SUBMENU;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "&Decoder";
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	menuitem.hSubMenu = submenu;
	InsertMenuItem(menu, IDM_DECODER_SUBMENU_POS, TRUE, &menuitem);

	// Options menu
	submenu = CreatePopupMenu();
	menuitem.fMask = MIIM_TYPE|MIIM_ID;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "Toggle FullScreen\tEnter";
	menuitem.wID = IDM_TOGGLE_FULLSCREEN;
  	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 0, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_ID|MIIM_STATE;
	menuitem.fType = MFT_STRING;
	menuitem.fState = (always_on_top)?MFS_CHECKED:MFS_UNCHECKED;
	menuitem.dwTypeData = "Always on &top";
	menuitem.wID = IDM_ALWAYS_ON_TOP;
  	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 1, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_ID|MIIM_STATE;
	menuitem.fType = MFT_STRING;
	menuitem.fState = (aspect_ratio)?MFS_CHECKED:MFS_UNCHECKED;
	menuitem.dwTypeData = "&Aspect ratio";
	menuitem.wID = IDM_ASPECT_RATIO;
  	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 2, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_ID|MIIM_STATE;
	menuitem.fType = MFT_STRING;
	menuitem.fState = (use_double_buffering)?MFS_CHECKED:MFS_UNCHECKED;
	menuitem.dwTypeData = "T&riple buffering";
	menuitem.wID = IDM_USE_DOUBLE_BUFFERING;
  	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 3, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_ID|MIIM_STATE;
	menuitem.fType = MFT_STRING;
	menuitem.fState = (disable_ints)?MFS_CHECKED:MFS_UNCHECKED;
	menuitem.dwTypeData = "&Disable interrupts";
	menuitem.wID = IDM_CLI;
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 4, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE;
	menuitem.fType = MFT_SEPARATOR;
	InsertMenuItem(submenu, 5, TRUE, &menuitem);
	
	// Signal Source
	menuitem.fMask = MIIM_TYPE|MIIM_ID|MIIM_STATE;
	menuitem.fType = MFT_STRING;
	menuitem.fState = (signal_source==VIDEO_SVIDEO)?MFS_CHECKED:MFS_UNCHECKED;
	menuitem.dwTypeData = "SVideo";
	menuitem.wID = IDM_SVIDEO;
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 5, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_ID|MIIM_STATE;
	menuitem.fType = MFT_STRING;
	menuitem.fState = (signal_source==VIDEO_TUNER)?MFS_CHECKED:MFS_UNCHECKED;
	menuitem.dwTypeData = "Tuner";
	menuitem.wID = IDM_TUNER;
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 5, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_ID|MIIM_STATE;
	menuitem.fType = MFT_STRING;
	menuitem.fState = (signal_source==VIDEO_COMPOSITE)?MFS_CHECKED:MFS_UNCHECKED;
	menuitem.dwTypeData = "Composite";
	menuitem.wID = IDM_COMPOSITE;
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 5, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE;
	menuitem.fType = MFT_SEPARATOR;
	InsertMenuItem(submenu, 4, TRUE, &menuitem);

	InsertMenuItem(submenu, 6, TRUE, &menuitem);
	menuitem.fMask = MIIM_TYPE|MIIM_SUBMENU;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "&Options";
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	menuitem.hSubMenu = submenu;
	InsertMenuItem(menu, IDM_OPTIONS_SUBMENU_POS, TRUE, &menuitem);

	// Help menu
	submenu = CreatePopupMenu();
	menuitem.fMask = MIIM_TYPE|MIIM_ID;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "&System info";
	menuitem.wID = IDM_SYSTEM_INFO;
  	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 0, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_ID;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "&About ...";
	menuitem.wID = IDM_ABOUT;
  	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 1, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_ID;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "&Keys...";
	menuitem.wID = IDM_KEY_HELP;
  	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	InsertMenuItem(submenu, 2, TRUE, &menuitem);

	menuitem.fMask = MIIM_TYPE|MIIM_SUBMENU;
	menuitem.fType = MFT_STRING;
	menuitem.dwTypeData = "&Help";
	menuitem.cch = strlen((char*)menuitem.dwTypeData);
	menuitem.hSubMenu = submenu;
	InsertMenuItem(menu, IDM_HELP_SUBMENU_POS, TRUE, &menuitem);

	return(menu);
}



